#include <iostream>
#include <cstdlib>

using namespace std;

class Ave {
	public:
		virtual void volar(void) = 0;
		virtual void comer(void) = 0;
		virtual void tamano(void) = 0;
};

class Gallina : public Ave {
	public:
		virtual void volar(void);
		virtual void comer(void);
		virtual void tamano(void);
};

void Gallina::volar(void)
{
	cout << "vuelo, pero sólo poquito como un brinco grande\n";
}

void Gallina::comer(void)
{
	cout << "como maíz y uno que otro gusano\n";
}

void Gallina::tamano(void)
{
	cout << "soy mediana\n";
}

class Aguila : public Ave {
	public:
		virtual void volar(void);
		virtual void comer(void);
		virtual void tamano(void);
};

void Aguila::volar(void)
{
	cout << "vuelo muy alto, sobre las montañas\n";
}

void Aguila::comer(void)
{
	cout << "como serpientes cuando me paro en un nopal\n";
}

void Aguila::tamano(void)
{
	cout << "soy grande\n";
}

class Golondrina : public Ave {
	public:
		virtual void volar(void);
		virtual void comer(void);
		virtual void tamano(void);
};

void Golondrina::volar(void)
{
	cout << "vuelo no muy alto, pero grandes distancias\n";
}

void Golondrina::comer(void)
{
	cout << "como gusanos\n";
}

void Golondrina::tamano(void)
{
	cout << "soy peque\n";
}

int main(int argc, char *argv[])
{
	Ave *a;

	cout << "Qué ave quieres? (g, a, s)\n";
	switch (cin.get()) {
		case 'g':	a= new Gallina();
					break;
		case 'a':	a= new Aguila();
					break;
		case 's':	a= new Golondrina();
					break;
		default:	a= NULL;
	}
	a->volar();
	a->comer();
	a->tamano();
	return EXIT_SUCCESS;
}
