#include <iostream>
#include <cstdlib>

using namespace std;

enum {
	PLUS, MINUS, ASTER, DIV, MOD, PLUSPLUS, PLUSEQ, 
	EQ, EQEQ, MINUSMINUS, MINUSEQ,
	BAD
};

const char* syname[] = {
	"PLUS", "MINUS", "ASTER", "DIV", "MOD", "PLUSPLUS", "PLUSEQ", 
	"EQ", "EQEQ", "MINUSMINUS", "MINUSEQ",
	"BAD"
};
	
int tok;

int GetTok(void)
{
	int  ch;
	cin >> ws;			// ws = white space 
	ch= cin.get();
	switch(ch) {
		case '+': 	if (cin.peek()=='+') {
						cin.get();
						tok= PLUSPLUS;
					}	
					else
					if (cin.peek()=='=') {
						cin.get();
						tok= PLUSEQ;
					}	
					else
						tok= PLUS;
					break;

		case '-': 	if (cin.peek()=='-') {
						cin.get();
						tok= MINUSMINUS;
					}	
					else
					if (cin.peek()=='=') {
						cin.get();
						tok= MINUSEQ;
					}	
					else
						tok= MINUS;
					break;
		case '*':	tok= ASTER;
					break;
		case '/':	tok= DIV;
					break;
		case '%':	tok= MOD;
					break;
		case '=':	if (cin.peek()=='=') {
						cin.get();
						tok= EQEQ;
					}
					else
						tok= EQ;
					break;
		default:	tok= BAD;
					break;
	}
	return tok;
}




int main(int argc, char *argv[])
{
	do {
		GetTok();
		cout << syname[tok] << endl;
	} while (tok != BAD);
	return EXIT_SUCCESS;
}
